<?php

require_once 'base/FpaParamferiasmEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  alessandrobartels
 */
class FpaParamferiasmEntity extends FpaParamferiasmEntityBase
{


    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;

    private $_paramFerias;
    private $_nrParamFeriasAnterior;


    /**
     * Construtor.
     *
     * @param integer 	 $id			 Identificador.
     * @param integer 	 $nrOrg			 Numero da organizacao de trabalho.
     * @param integer    $nrOrgPadrao	 Numero da organizacao padrao.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     *
     * @author thalesvalias - 02/12/11
     */
    public function __construct($id = null, $nrOrg = null, $nrOrgPadrao = null, TkDateTime $mesCompetencia = null){

        parent::__construct($id);

        $this->_nrOrg = $nrOrg;
        $this->_nrOrgPadrao = $nrOrgPadrao;
        $this->_mesCompetencia = $mesCompetencia;
        $this->_nrParamFeriasAnterior = -1;

    }


    /**
     * Percentual de adiantamento de 13 salario em ferias.
     *
     * @return float
     *
     * @author thalesvalias - 02/12/11
     */
    public function getPercentualAdiantamento13Salario(){
        if (is_object($this->_paramFerias) === true) {
            return $this->_paramFerias->historico->getVrpeadiant13sal();
        }
    }


    /**
     * Numero de dias de ferias para provisao.
     *
     * @return integer
     *
     * @author thalesvalias - 02/12/11
     */
    public function getNrDiasFeriasProvisao(){
        if (is_object($this->_paramFerias) === true) {
            return $this->_paramFerias->historico->getNrdiasferiaprov();
        }
    }


     /**
     * Percentual de provisao.
     *
     * @return float
     *
     * @author thalesvalias - 02/12/11
     */
    public function getPercentualProvisao(){
        if (is_object($this->_paramFerias) === true) {
            return $this->_paramFerias->historico->getVrpeprovisao();
        }
    }


    /**
     * Procura o parametro de ferias na lista.
     *
     * @param integer $nrParamFerias Numero do parametro de ferias.
     *
     * @return void
     *
     * @author thalesvalias - 02/12/11
     */
    public function procuraParamFerias($nrParamFerias){
        if ($this->_nrParamFeriasAnterior !== $nrParamFerias) {
            $itens = $this->getItems();
            if (count($itens) === 0) {
                $this->_inicializaListaParametroFerias();
                $itens = $this->getItems();
            }

            foreach ($itens as $key => $item) {
                if ((int)$item->getNrparamferiasm() === (int)$nrParamFerias) {
                    $this->_paramFerias = $this->getItem($key);
                    break;
                }
            }
        }
    }


     /**
     * Adiciona na lista instancias de FpaparamferiasmEntity agregado com FpaparamferiashEntity.
     *
     * @throws Exception $e Propaga excecao.
     *
     * @return void
     *
     * @author thalesvalias - 02/12/11
     */
    private function _inicializaListaParametroFerias(){
            $itens = FpaParamferiasm::retornaParametrosFerias(
                $this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia
            );
            if(count($itens)==0){
                throw new Exception('Não foi encontrado parâmetro de férias ou o mesmo está incorreto para a estrutura. Confira os parâmetros de estrutura.');
            }

            foreach ($itens as $item) {
                $this->addItem($item);
            }

    }

    /**
     * @param $nrorg
     *
     * @return FpaParamferiasmEntity
     * @autor jorgefonseca
     */
    public static function getByNrorg($nrorg) {

        $result = self::getEntityByWhere('NRORG = ?', array($nrorg));
        return $result;
    }

}

