<?php
/**
 * Created by JetBrains PhpStorm.
 *
 * @package Logic
 * @author  guilhermefernandes
 * Date: 21/10/10
 * Time: 13:28
 * To change this template use File | Settings | File Templates.
 */

class PersonalLogic {

    const PER_FILE_SIZE = 319;
    const PER_FILE_OFFSET = 2;
    /*
     * Constantes que indicam a posicao de cada valor no PER.
     */
    const ppNomeFant = 0;
    const ppRazaoSoc = 30;
    const ppEndereco = 60;
    const ppBairro = 101;
    const ppCidade = 121;
    const ppEstado = 141;
    const ppPais = 143;
    const ppCEP = 163;
    const ppTelefone = 171;
    const ppFax = 183;
    const ppInscEsta = 195;
    const ppInscrJur = 215;
    const ppValidade = 235;
    const ppLimConex = 245;
    const ppSistemas = 249;
    const ppModuFili = 309;
    const ppFilialPr = 310;
    const ppFechamen = 314;
    const ppLocaProc = 320;
    /*
     * Constantes que indicam o tamanho de cada valor no PER.
     */
    const tpNomeFant = 30;
    const tpRazaoSoc = 30;
    const tpEndereco = 40;
    const tpBairro = 20;
    const tpCidade = 20;
    const tpEstado = 2;
    const tpPais = 20;
    const tpCEP = 8;
    const tpTelefone = 12;
    const tpFax = 12;
    const tpInscEsta = 20;
    const tpInscrJur = 20;
    const tpValidade = 10;
    const tpLimConex = 4;
    const tpSistemas = 60;
    const tpModuFili = 1;
    const tpFilialPr = 4;
    const tpFechamen = 6;
    const tpLocaProc = 1;

	private $_stringPersonalizacao;  // String de controle do arquivo de Personalizacao
	private $_antesVencimento30Dias; // Periodo de 30 (trinta) dias antes do vencimento
	private $_vencido;               // Verifica se o sistema ja esta vencido
	private $_nomeFantasia;          // Nome Fantasia da empresa
	private $_razaoSocial;           // Razao Social da empresa
	private $_endereco;              // Endereco da empresa
	private $_bairro;                // Bairro da empresa
	private $_cidade;                // Cidade da empresa
	private $_estado;                // Estado da empresa
	private $_pais;                  // Pais da empresa
	private $_cep;                   // CEP da empresa
	private $_telefone;              // Telefone da empresa
	private $_fax;                   // Fax da empresa
	private $_inscricaoEstadual;     // Inscricao Estadual da empresa
	private $_inscricaoJuridica;     // C.G.C. da empresa
	private $_validade;              // Data de vencimento do sistema
	private $_limiteConexoes;        // Numero maximo de conexoes simultaneas.
	private $_sistemas;              // Sistemas habilitados para uso.
	private $_nomeArquivo;           // Nome do arquivo de Personalizacao
	private $_modoFilial;            // Modo de processamento na Filial (Sim/Nao).
	private $_filialProcessamento;   // Filial de Processamento.
	private $_fechamento;            // Fechamento do arquivo.
	private $_localProcessamento;    // Local de Processamento.


	public function getAntesVencimento30Dias()
	{
		return $this->_antesVencimento30Dias;
	}


	public function getBairro()
	{
		return $this->_bairro;
	}


	public function getCep()
	{
		return $this->_cep;
	}


	public function getCidade()
	{
		return $this->_cidade;
	}


	public function getEndereco()
	{
		return $this->_endereco;
	}


	public function getEstado()
	{
		return $this->_estado;
	}


	public function getFax()
	{
		return $this->_fax;
	}


	public function getFechamento()
	{
		return $this->_fechamento;
	}


	public function getFilialProcessamento()
	{
		return $this->_filialProcessamento;
	}


	public function getInscricaoEstadual()
	{
		return $this->_inscricaoEstadual;
	}


	public function getInscricaoJuridica()
	{
		return $this->_inscricaoJuridica;
	}


	public function getLimiteConexoes()
	{
		return $this->_limiteConexoes;
	}


	public function getLocalProcessamento()
	{
		return $this->_localProcessamento;
	}


	public function getModoFilial()
	{
		return $this->_modoFilial;
	}


	public function getNomeArquivo()
	{
		return $this->_nomeArquivo;
	}


	public function getNomeFantasia()
	{
		return $this->_nomeFantasia;
	}


	public function getPais()
	{
		return $this->_pais;
	}


	public function getRazaoSocial()
	{
		return $this->_razaoSocial;
	}


	public function getSistemas()
	{
		return $this->_sistemas;
	}


	public function getStringPersonalizacao()
	{
		return $this->_stringPersonalizacao;
	}


	public function getTelefone()
	{
		return $this->_telefone;
	}


	public function getValidade()
	{
		return $this->_validade;
	}


	public function getVencido()
	{
		return $this->_vencido;
	}


    /**
     * Construtor.
     *
     * @param string $cdfilial Codigo da filial.
     */
    function __construct($cdfilial) {
        $arquivo = $this->_validaArquivoPersonal($cdfilial);
        $arquivo = trim($arquivo);
	    $descriptografa = CriptografiaLogic::descriptografa($arquivo, self::PER_FILE_OFFSET);
        $this->_preencheDados($arquivo, $descriptografa);
        $this->persStrOk($cdfilial); // Chama a funcao para testes.
    }


    /**
     * Verifica se arquivo existe e retorna arquivo em forma de string.
     *
     * @param string $cdfilial Codigo da filial.
     *
     * @return string
     */
    private function _validaArquivoPersonal($cdfilial) {
        $diretorio = 'C:/workfolder/fpa-teknisa/products/pers/PERS'.$cdfilial.'.TEK';
        if (file_exists($diretorio) === false) {
            throw new Exception('msg_ArqPersNDisp');
        }

	    $arquivo = '';
        $arquivoTek = fopen($diretorio, 'r');
	    while(feof($arquivoTek) === false) {
		    $arquivo .= fgets($arquivoTek);
	    }

	    if (is_string($arquivo) === false) {
            throw new Exception('msg_PersInv');
        }

	    return $arquivo;
    }


    /**
     * Retorna um array com os dados preenchidos.
     *
     * @static
     * @param $arquivoTek
     * @param $descriptografado
     * @return array
     */
    private function _preencheDados($arquivoTek, $descriptografado){
        $arrayArquivoTek = explode(chr(13), $descriptografado);

	    $sistema = '';
        for ($i = 0; $i <= ((count($arrayArquivoTek))-3);$i++) {
            $sistema[] = trim($arrayArquivoTek[$i]);
        }

	    $fechamento = (int)$arrayArquivoTek[count($arrayArquivoTek)-2];

	    $validade = new Zend_Date(substr($descriptografado, self::ppValidade, self::tpValidade));
	    $hoje = new Zend_Date(date('d/m/Y'));
	    $vencido = ($hoje->compare($validade))? 'S' : 'N';
	    $antesVencimento30Dias = new Zend_Date($validade);
	    $antesVencimento30Dias->subDay(30);

	    $this->_nomeArquivo           = realpath($arquivoTek);
		 $this->_stringPersonalizacao  = $arquivoTek;
		 $this->_antesVencimento30Dias = $antesVencimento30Dias->get('d/M/Y');
		 $this->_vencido               = $vencido;
		 $this->_nomeFantasia          = substr($descriptografado, self::ppNomeFant, self::tpNomeFant);
		 $this->_razaoSocial           = substr($descriptografado, self::ppRazaoSoc, self::tpRazaoSoc);
		 $this->_endereco              = substr($descriptografado, self::ppEndereco, self::tpEndereco);
		 $this->_bairro                = substr($descriptografado, self::ppBairro, self::tpBairro);
		 $this->_cidade                = substr($descriptografado, self::ppCidade, self::tpCidade);
		 $this->_estado                = substr($descriptografado, self::ppEstado, self::tpEstado);
		 $this->_pais                  = substr($descriptografado, self::ppPais, self::tpPais);
		 $this->_cep                   = substr($descriptografado, self::ppCEP, self::tpCEP);
		 $this->_telefone              = substr($descriptografado, self::ppTelefone, self::tpTelefone);
		 $this->_fax                   = substr($descriptografado, self::ppFax, self::tpFax);
		 $this->_inscricaoEstadual     = substr($descriptografado, self::ppInscEsta, self::tpInscEsta);
		 $this->_inscricaoJuridica     = substr($descriptografado, self::ppInscrJur, self::tpInscrJur);
		 $this->_validade              = $validade->get('d/M/Y');
		 $this->_limiteConexoes        = substr($descriptografado, self::ppLimConex, self::tpLimConex);
		 $this->_sistemas              = $sistema;
		 $this->_modoFilial            = substr($descriptografado, self::ppModuFili, self::tpModuFili);
		 $this->_filialProcessamento   = substr($descriptografado, self::ppFilialPr, self::tpFilialPr);
		 $this->_fechamento            = $fechamento;
		 $this->_localProcessamento    = substr($descriptografado, self::ppLocaProc, self::tpLocaProc);
    }


    /**
     * Faz a verificacao.
     *
     * @param string $personalDados Personal String.
     * @param string $cdfilial      Codigo da Filial.
     *
     * @return void
     */
    public function persStrOk($cdfilial) {

//        if (count($personalDados) <= 1) {
//            throw new Exception('msg_PersInv');// Arquivo de Personalizacao invalido.
//        }

//        self::persFecham($personalDados);

        /*
        if (self::persFecham($personalDados) !== $personalDados[count($personalDados) - 2]) {
            throw new Exception('400067'); // Arquivo de Personalizacao invalido.
        }
        */

        /*
        if (PersonalLogic::persFecham(($stPersStr) !== $personalDados[count($personalDados) - 2])) {
            tk_show_message(400067);
            // Arquivo de Personalizacao invalido.
        }
        */

        if ($this->_filialProcessamento !== $cdfilial) {
        	throw new Exception('msg_FiliPersInv'); // Codigo da filial do arquivo de Personalizacao invalido.
        }

        if (($this->_modoFilial === 'S') and ($this->_localProcessamento === 'M')) {
            throw new Exception('msg_FiliNAces'); // A filial apenas pode ser utilizada em operacoes realizadas na Matriz.
                                           // Faca o login utilizando uma filial com status de Matriz.
        }
    }


    /**
     * Vou descobrir.
     *
     * @param array $stPersStr Array de dados.
     * @param mixed $stNewPer  A?????.
     *
     * @return mixed
     */
    public static function persFecham(array $stPersStr,$stNewPer = '') {

	    $Result = '';
        $inValue = 0;
        $stPersStrstring = self::mtkGeraString($stPersStr).chr(13);

        if ($stNewPer === '') {
            if (count($stPersStr) > 1) {
                for ($inIndex = 0; $inIndex <= ((strlen($stPersStrstring))-9); $inIndex++) {
                    $inValue = ord($stPersStrstring[$inIndex]) + $inValue;
                }

                $Result = str_pad($inValue, 6, '0', STR_PAD_LEFT);
                return $Result;
            }
        } else {
            if ($stNewPer === 'S') {
                for ($inIndex = 1; $inIndex <= (strlen($stPersStrstring) - 8); $inIndex++) {
                    $inValue = ord($stPersStrstring[$inIndex]) + $inValue;
                }

                $Result = str_pad($inValue, 6, '0', STR_PAD_LEFT);
                return $Result;
            }
        }
	    return $Result;
    }


    /**
     * Gera string.
     *
     * @param string $param    A???.
     * @param string $caracter A???.
     *
     * @return string|mixed
     */
    public static function mtkGeraString($param, $caracter = 13) {
        $retorno = '';
        $count = count($param);
        $count = $count - 1;
        if ((is_string($param)) === false) {
            foreach ($param as $key => $valor) {
                if ($key<=$count-1) {
                    $retorno = $retorno.$valor.(chr($caracter));
                }
            }

            return $retorno;
        }

        return $param;
    }


}